Index: gdbserver/Makefile.in
===================================================================
RCS file: /cvs/src/src/gdb/gdbserver/Makefile.in,v
retrieving revision 1.28
diff -u -r1.28 Makefile.in
--- gdbserver/Makefile.in	4 Mar 2005 18:16:25 -0000	1.28
+++ gdbserver/Makefile.in	13 Apr 2005 07:52:03 -0000
@@ -121,6 +121,7 @@
 	$(srcdir)/linux-arm-low.c $(srcdir)/linux-i386-low.c \
 	$(srcdir)/i387-fp.c \
 	$(srcdir)/linux-ia64-low.c $(srcdir)/linux-low.c \
+	$(srcdir)/linux-m32r-low.c \
 	$(srcdir)/linux-m68k-low.c $(srcdir)/linux-mips-low.c \
 	$(srcdir)/linux-ppc-low.c $(srcdir)/linux-s390-low.c \
 	$(srcdir)/linux-sh-low.c $(srcdir)/linux-x86-64-low.c
@@ -198,7 +199,7 @@
 clean:
 	rm -f *.o ${ADD_FILES} *~
 	rm -f gdbserver gdbreplay core make.log
-	rm -f reg-arm.c reg-i386.c reg-ia64.c reg-m68k.c reg-mips.c
+	rm -f reg-arm.c reg-i386.c reg-ia64.c reg-m32r.c reg-m68k.c reg-mips.c
 	rm -f reg-ppc.c reg-sh.c reg-x86-64.c reg-i386-linux.c
 
 maintainer-clean realclean distclean: clean
@@ -281,6 +282,9 @@
 reg-ia64.o : reg-ia64.c $(regdef_h)
 reg-ia64.c : $(srcdir)/../regformats/reg-ia64.dat $(regdat_sh)
 	sh $(regdat_sh) $(srcdir)/../regformats/reg-ia64.dat reg-ia64.c
+reg-m32r.o : reg-m32r.c $(regdef_h)
+reg-m32r.c : $(srcdir)/../regformats/reg-m32r.dat $(regdat_sh)
+	sh $(regdat_sh) $(srcdir)/../regformats/reg-m32r.dat reg-m32r.c
 reg-m68k.o : reg-m68k.c $(regdef_h)
 reg-m68k.c : $(srcdir)/../regformats/reg-m68k.dat $(regdat_sh)
 	sh $(regdat_sh) $(srcdir)/../regformats/reg-m68k.dat reg-m68k.c
Index: gdbserver/configure.srv
===================================================================
RCS file: /cvs/src/src/gdb/gdbserver/configure.srv,v
retrieving revision 1.8
diff -u -r1.8 configure.srv
--- gdbserver/configure.srv	21 Nov 2004 03:09:39 -0000	1.8
+++ gdbserver/configure.srv	13 Apr 2005 07:52:03 -0000
@@ -33,6 +33,11 @@
 			srv_tgtobj="linux-low.o linux-ia64-low.o"
 			srv_linux_usrregs=yes
 			;;
+  m32r*-*-linux*)	srv_regobj=reg-m32r.o
+			srv_tgtobj="linux-low.o linux-m32r-low.o"
+			srv_linux_usrregs=yes
+ 			srv_linux_thread_db=yes
+			;;
   m68*-*-linux*)	srv_regobj=reg-m68k.o
 			srv_tgtobj="linux-low.o linux-m68k-low.o"
 			srv_linux_usrregs=yes
Index: gdbserver/linux-m32r-low.c
===================================================================
RCS file: gdbserver/linux-m32r-low.c
diff -N gdbserver/linux-m32r-low.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gdbserver/linux-m32r-low.c	13 Apr 2005 07:52:03 -0000
@@ -0,0 +1,98 @@
+/* GNU/Linux/m32r specific low level interface, for the remote server for GDB.
+   Copyright 2005 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.  */
+
+#include "server.h"
+#include "linux-low.h"
+
+#ifdef HAVE_SYS_REG_H
+#include <sys/reg.h>
+#endif
+
+#define m32r_num_regs 25
+
+static int m32r_regmap[] = {
+#ifdef PT_R0
+  PT_R0, PT_R1, PT_R2, PT_R3, PT_R4, PT_R5, PT_R6, PT_R7,
+  PT_R8, PT_R9, PT_R10, PT_R11, PT_R12, PT_FP, PT_LR, PT_SPU,
+  PT_PSW, PT_CBR, PT_SPI, PT_SPU, PT_BPC, PT_PC, PT_ACCL, PT_ACCH, PT_EVB
+#else
+  4 * 4, 4 * 5, 4 * 6, 4 * 7, 4 * 0, 4 * 1, 4 * 2, 4 * 8,
+  4 * 9, 4 * 10, 4 * 11, 4 * 12, 4 * 13, 4 * 24, 4 * 25, 4 * 23,
+  4 * 19, 4 * 31, 4 * 26, 4 * 23, 4 * 20, 4 * 30, 4 * 16, 4 * 15, 4 * 32
+#endif
+};
+
+static int
+m32r_cannot_store_register (int regno)
+{
+  return (regno >= m32r_num_regs);
+}
+
+static int
+m32r_cannot_fetch_register (int regno)
+{
+  return (regno >= m32r_num_regs);
+}
+
+static CORE_ADDR
+m32r_get_pc ()
+{
+  unsigned long pc;
+  collect_register_by_name ("pc", &pc);
+  return pc;
+}
+
+static void
+m32r_set_pc (CORE_ADDR pc)
+{
+  unsigned long newpc = pc;
+  supply_register_by_name ("pc", &newpc);
+}
+
+static const unsigned short m32r_breakpoint = 0x10f1;
+#define m32r_breakpoint_len 2
+
+static int
+m32r_breakpoint_at (CORE_ADDR where)
+{
+  unsigned short insn;
+
+  (*the_target->read_memory) (where, (char *) &insn, m32r_breakpoint_len);
+  if (insn == m32r_breakpoint)
+    return 1;
+
+  /* If necessary, recognize more trap instructions here.  GDB only uses the
+     one.  */
+  return 0;
+}
+
+struct linux_target_ops the_low_target = {
+  m32r_num_regs,
+  m32r_regmap,
+  m32r_cannot_fetch_register,
+  m32r_cannot_store_register,
+  m32r_get_pc,
+  m32r_set_pc,
+  (const char *) &m32r_breakpoint,
+  m32r_breakpoint_len,
+  NULL,
+  0,
+  m32r_breakpoint_at,
+};
Index: regformats/reg-m32r.dat
===================================================================
RCS file: regformats/reg-m32r.dat
diff -N regformats/reg-m32r.dat
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ regformats/reg-m32r.dat	13 Apr 2005 07:52:03 -0000
@@ -0,0 +1,27 @@
+name:m32r
+expedite:pc,lr,sp
+32:r0
+32:r1
+32:r2
+32:r3
+32:r4
+32:r5
+32:r6
+32:r7
+32:r8
+32:r9
+32:r10
+32:r11
+32:r12
+32:fp
+32:lr
+32:sp
+32:psw
+32:cbr
+32:spi
+32:spu
+32:bpc
+32:pc
+32:accl
+32:acch
+32:evb
